summaryrefslogtreecommitdiffstats
path: root/source/xap/xpdf
diff options
context:
space:
mode:
Diffstat (limited to 'source/xap/xpdf')
-rw-r--r--source/xap/xpdf/patches/03-float.patch25
-rwxr-xr-xsource/xap/xpdf/xpdf.SlackBuild7
2 files changed, 29 insertions, 3 deletions
diff --git a/source/xap/xpdf/patches/03-float.patch b/source/xap/xpdf/patches/03-float.patch
new file mode 100644
index 000000000..208c765ad
--- /dev/null
+++ b/source/xap/xpdf/patches/03-float.patch
@@ -0,0 +1,25 @@
+description: fix a floating point quirk that is exposed by gcc 4.4
+ (this was leading to slow pdf document scrolling on i386)
+author: Michael Gilbert <michael.s.gilbert@gmail.com>
+bug-debian: http://bugs.debian.org/577031
+--- xpdf-3.02.orig/xpdf/PDFCore.h
++++ xpdf-3.02/xpdf/PDFCore.h
+@@ -40,6 +40,7 @@ class PDFCore;
+ #define zoomPage -1
+ #define zoomWidth -2
+ #define defZoom 125
++#define EPSILON 1.0e-7 // 32-bit floating point machine precision
+
+ //------------------------------------------------------------------------
+
+--- xpdf-3.02.orig/xpdf/PDFCore.cc
++++ xpdf-3.02/xpdf/PDFCore.cc
+@@ -445,7 +445,7 @@ void PDFCore::update(int topPageA, int s
+ // object
+ if (force || pages->getLength() == 0 ||
+ (!continuousMode && topPageA != topPage) ||
+- zoomA != zoom || dpiA != dpi || rotateA != rotate) {
++ zoomA != zoom || fabs( dpiA - dpi ) > EPSILON || rotateA != rotate) {
+ needUpdate = gTrue;
+ setSelection(0, 0, 0, 0, 0);
+ while (pages->getLength() > 0) {
diff --git a/source/xap/xpdf/xpdf.SlackBuild b/source/xap/xpdf/xpdf.SlackBuild
index b19b3aca7..6093f21d8 100755
--- a/source/xap/xpdf/xpdf.SlackBuild
+++ b/source/xap/xpdf/xpdf.SlackBuild
@@ -1,6 +1,6 @@
#!/bin/sh
-# Copyright 2008, 2009, 2010, 2011 Patrick J. Volkerding, Sebeka, MN, USA
+# Copyright 2008, 2009, 2010, 2011, 2012 Patrick J. Volkerding, Sebeka, MN, USA
# All rights reserved.
#
# Redistribution and use of this script, with or without modification, is
@@ -23,7 +23,7 @@
VERSION=3.02
PATCHLEVEL=pl6
-BUILD=${BUILD:-3}
+BUILD=${BUILD:-4}
NUMJOBS=${NUMJOBS:-" -j7 "}
@@ -78,6 +78,7 @@ cat $CWD/patches/xpdf-3.02pl4.patch | patch -p1 --verbose || exit 1
cat $CWD/patches/xpdf-3.02pl5.patch | patch -p1 --verbose || exit 1
zcat $CWD/patches/xpdf_3.02-1.3.diff.gz | patch -p1 --verbose || exit 1
zcat $CWD/patches/xpdfrc.diff.gz | patch -p1 --verbose || exit 1
+zcat $CWD/patches/03-float.patch.gz | patch -p1 --verbose || exit 1
CFLAGS="$SLKCFLAGS" \
CXXFLAGS="$SLKCFLAGS" \
@@ -89,7 +90,7 @@ CXXFLAGS="$SLKCFLAGS" \
--with-gzip \
--with-freetype2-includes=/usr/include/freetype2 \
--without-t1-library \
- --build=$ARCH-slackware-linux
+ --build=$ARCH-slackware-linux || exit 1
make $NUMJOBS || make || exit 1
make install DESTDIR=$PKG || exit 1